--- /dev/null	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/intel/os/fpu_subr.c	Wed Apr 12 20:33:33 2023
@@ -0,0 +1,219 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2018, Joyent, Inc.
+ */
+
+/*
+ * Floating point configuration.
+ */
+
+#include <sys/types.h>
+#include <sys/regset.h>
+#include <sys/privregs.h>
+#include <sys/x86_archext.h>
+#include <sys/archsystm.h>
+#include <sys/fp.h>
+#include <sys/cmn_err.h>
+#include <sys/exec.h>
+
+#define	XMM_ALIGN	16
+
+/*
+ * See section 10.5.1 in the Intel 64 and IA-32 Architectures Software
+ * Developer’s Manual, Volume 1.
+ */
+#define	FXSAVE_ALIGN	16
+
+/*
+ * See section 13.4 in the Intel 64 and IA-32 Architectures Software
+ * Developer’s Manual, Volume 1.
+ */
+#define	XSAVE_ALIGN	64
+
+/*
+ * If fpu_exists is non-zero, fpu_probe will attempt to use any
+ * hardware FPU (subject to other constraints, see below).  If
+ * fpu_exists is zero, fpu_probe will report that there is no
+ * FPU even if there is one.
+ */
+int fpu_exists = 1;
+
+int fp_kind = FP_387;
+
+/*
+ * The variable fpu_ignored is provided to allow other code to
+ * determine whether emulation is being done because there is
+ * no FPU or because of an override requested via /etc/system.
+ */
+int fpu_ignored = 0;
+
+/*
+ * Used by ppcopy and ppzero to determine whether or not to use the
+ * SSE-based pagecopy and pagezero routines
+ */
+int use_sse_pagecopy = 0;
+int use_sse_pagezero = 0;
+int use_sse_copy = 0;
+
+#if defined(__xpv)
+
+/*
+ * Use of SSE or otherwise is forcibly configured for us by the hypervisor.
+ */
+
+#define	ENABLE_SSE()
+#define	DISABLE_SSE()
+
+#else	/* __xpv */
+
+#define	ENABLE_SSE()	setcr4(CR4_ENABLE_SSE_FLAGS(getcr4()))
+#define	DISABLE_SSE()	setcr4(CR4_DISABLE_SSE_FLAGS(getcr4()))
+
+#endif	/* __xpv */
+
+/*
+ * Try and figure out what kind of FP capabilities we have, and
+ * set up the control registers accordingly.
+ */
+void
+fpu_probe(void)
+{
+	if (fpu_initial_probe() != 0)
+		goto nofpu;
+
+	if (fpu_exists == 0) {
+		fpu_ignored = 1;
+		goto nofpu;
+	}
+
+#ifndef __xpv
+	/*
+	 * Check and see if the fpu is present by looking
+	 * at the "extension type" bit.  (While this used to
+	 * indicate a 387DX coprocessor in days gone by,
+	 * it's forced on by modern implementations for
+	 * compatibility.)
+	 */
+	if ((getcr0() & CR0_ET) == 0)
+		goto nofpu;
+#endif
+
+	/* Use the more complex exception clearing code if necessary */
+	if (cpuid_need_fp_excp_handling())
+		fpsave_ctxt = fpxsave_excp_clr_ctxt;
+
+	/*
+	 * SSE and SSE2 are required for the 64-bit ABI.
+	 *
+	 * If they're not present, we can in principal run
+	 * 32-bit userland, though 64-bit processes will be hosed.
+	 *
+	 * (Perhaps we should complain more about this case!)
+	 */
+	if (is_x86_feature(x86_featureset, X86FSET_SSE) &&
+	    is_x86_feature(x86_featureset, X86FSET_SSE2)) {
+		fp_kind |= __FP_SSE;
+		ENABLE_SSE();
+
+		if (is_x86_feature(x86_featureset, X86FSET_AVX)) {
+			ASSERT(is_x86_feature(x86_featureset, X86FSET_XSAVE));
+			fp_kind |= __FP_AVX;
+		}
+
+		if (is_x86_feature(x86_featureset, X86FSET_XSAVE)) {
+			fp_save_mech = FP_XSAVE;
+			fp_elf = AT_386_FPINFO_XSAVE;
+			if (is_x86_feature(x86_featureset, X86FSET_XSAVEOPT)) {
+				/*
+				 * Use the more complex exception
+				 * clearing code if necessary.
+				 */
+				if (cpuid_need_fp_excp_handling()) {
+					fpsave_ctxt = xsaveopt_excp_clr_ctxt;
+					fp_elf = AT_386_FPINFO_XSAVE_AMD;
+				} else {
+					fpsave_ctxt = xsaveopt_ctxt;
+				}
+				xsavep = xsaveopt;
+			} else {
+				/*
+				 * Use the more complex exception
+				 * clearing code if necessary.
+				 */
+				if (cpuid_need_fp_excp_handling()) {
+					fpsave_ctxt = xsave_excp_clr_ctxt;
+					fp_elf = AT_386_FPINFO_XSAVE_AMD;
+				} else {
+					fpsave_ctxt = xsave_ctxt;
+				}
+			}
+			fprestore_ctxt = xrestore_ctxt;
+			fpsave_cachep = kmem_cache_create("xsave_cache",
+			    cpuid_get_xsave_size(), XSAVE_ALIGN,
+			    NULL, NULL, NULL, NULL, NULL, 0);
+		} else {
+			/* fp_save_mech defaults to FP_FXSAVE */
+			fpsave_cachep = kmem_cache_create("fxsave_cache",
+			    sizeof (struct fxsave_state), FXSAVE_ALIGN,
+			    NULL, NULL, NULL, NULL, NULL, 0);
+			fp_elf = AT_386_FPINFO_FXSAVE;
+		}
+	}
+
+	if (is_x86_feature(x86_featureset, X86FSET_SSE2)) {
+		use_sse_pagecopy = use_sse_pagezero = use_sse_copy = 1;
+	}
+
+	if (fp_kind & __FP_SSE) {
+		struct fxsave_state *fx;
+		uint8_t fxsave_state[sizeof (struct fxsave_state) + XMM_ALIGN];
+
+		/*
+		 * Extract the mxcsr mask from our first fxsave
+		 */
+		fx = (void *)(((uintptr_t)(&fxsave_state[0]) +
+		    XMM_ALIGN) & ~(XMM_ALIGN - 1ul));
+
+		fx->fx_mxcsr_mask = 0;
+		fxsave_insn(fx);
+		if (fx->fx_mxcsr_mask != 0) {
+			/*
+			 * Override default mask initialized in fpu.c
+			 */
+			sse_mxcsr_mask = fx->fx_mxcsr_mask;
+		}
+	}
+
+	setcr0(CR0_ENABLE_FPU_FLAGS(getcr0()));
+	return;
+
+	/*
+	 * No FPU hardware present
+	 */
+nofpu:
+	setcr0(CR0_DISABLE_FPU_FLAGS(getcr0()));
+	DISABLE_SSE();
+	fp_kind = FP_NO;
+	fpu_exists = 0;
+}
--- old/usr/src/uts/intel/os/sendsig.c	Wed Apr 12 20:33:33 2023
+++ new/usr/src/uts/intel/os/sendsig.c	Wed Apr 12 20:33:33 2023
@@ -31,6 +31,10 @@
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T   */
 /*	All Rights Reserved   */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/sysmacros.h>
@@ -112,9 +116,10 @@
  *		<128 bytes of untouched stack space>
  *		<a siginfo_t [optional]>
  *		<a ucontext_t>
- *		<siginfo_t *>
- *		<signal number>
- * new %rsp:	<return address (deliberately invalid)>
+ *		<a ucontext_t's xsave state>
+ *		<siginfo_t *>                             ---+
+ *		<signal number>                              | sigframe
+ * new %rsp:	<return address (deliberately invalid)>   ---+
  *
  * The signal number and siginfo_t pointer are only pushed onto the stack in
  * order to allow stack backtraces.  The actual signal handling code expects the
@@ -130,8 +135,10 @@
 int
 sendsig(int sig, k_siginfo_t *sip, void (*hdlr)())
 {
-	volatile int minstacksz;
-	int newstack;
+	volatile size_t minstacksz;
+	boolean_t newstack;
+	size_t xsave_size;
+	int ret;
 	label_t ljb;
 	volatile caddr_t sp;
 	caddr_t fp;
@@ -171,14 +178,26 @@
 	 * which must be 16-byte aligned. Because of this, for correct
 	 * alignment, sigframe must be a multiple of 8-bytes in length, but
 	 * not 16-bytes. This will place ucontext_t at a nice 16-byte boundary.
+	 *
+	 * When we move onto the xsave state, right now, we don't guarantee any
+	 * alignment of the resulting data, but we will ensure that the
+	 * resulting sp does have proper alignment. This will ensure that the
+	 * guarantee on the ucontex_t is not violated.
 	 */
 
-	/* LINTED: logical expression always true: op "||" */
-	ASSERT((sizeof (struct sigframe) % 16) == 8);
+	CTASSERT((sizeof (struct sigframe) % 16) == 8);
 
 	minstacksz = sizeof (struct sigframe) + SA(sizeof (*uc));
 	if (sip != NULL)
 		minstacksz += SA(sizeof (siginfo_t));
+
+	if (fpu_xsave_enabled()) {
+		xsave_size = SA(fpu_signal_size(lwp));
+		minstacksz += xsave_size;
+	} else {
+		xsave_size = 0;
+	}
+
 	ASSERT((minstacksz & (STACK_ENTRY_ALIGN - 1ul)) == 0);
 
 	/*
@@ -295,16 +314,26 @@
 	} else
 		sip_addr = NULL;
 
+	no_fault();
+
 	/*
-	 * save the current context on the user stack directly after the
-	 * sigframe. Since sigframe is 8-byte-but-not-16-byte aligned,
-	 * and since sizeof (struct sigframe) is 24, this guarantees
-	 * 16-byte alignment for ucontext_t and its %xmm registers.
+	 * Save the current context on the user stack directly after the
+	 * sigframe. Since sigframe is 8-byte-but-not-16-byte aligned, and since
+	 * sizeof (struct sigframe) is 24, this guarantees 16-byte alignment for
+	 * ucontext_t and its %xmm registers. The xsave state part of the
+	 * ucontext_t may be inbetween these two. However, we have ensured that
+	 * the size of the stack space is 16-byte aligned as the actual size may
+	 * vary.
 	 */
-	uc = (ucontext_t *)(sp + sizeof (struct sigframe));
 	tuc = kmem_alloc(sizeof (*tuc), KM_SLEEP);
-	no_fault();
-	savecontext(tuc, &lwp->lwp_sigoldmask);
+	if (xsave_size != 0) {
+		tuc->uc_xsave = (unsigned long)(sp + sizeof (struct sigframe));
+	}
+	uc = (ucontext_t *)(sp + sizeof (struct sigframe) + xsave_size);
+	ret = savecontext(tuc, &lwp->lwp_sigoldmask, SAVECTXT_F_EXTD |
+	    SAVECTXT_F_ONFAULT);
+	if (ret != 0)
+		goto postfault;
 	if (on_fault(&ljb))
 		goto badstack;
 	copyout_noerr(tuc, uc, sizeof (*tuc));
@@ -378,6 +407,7 @@
 
 badstack:
 	no_fault();
+postfault:
 	if (watched)
 		watch_enable_addr((caddr_t)sp, minstacksz, S_WRITE);
 	if (tuc)
@@ -399,6 +429,7 @@
  * old %esp:
  *		<a siginfo32_t [optional]>
  *		<a ucontext32_t>
+ *		<a ucontext32_t's xsave state>
  *		<pointer to that ucontext32_t>
  *		<pointer to that siginfo32_t>
  *		<signo>
@@ -414,8 +445,10 @@
 int
 sendsig32(int sig, k_siginfo_t *sip, void (*hdlr)())
 {
-	volatile int minstacksz;
-	int newstack;
+	volatile size_t minstacksz;
+	boolean_t newstack;
+	size_t xsave_size;
+	int ret;
 	label_t ljb;
 	volatile caddr_t sp;
 	caddr_t fp;
@@ -434,6 +467,13 @@
 	minstacksz = SA32(sizeof (struct sigframe32)) + SA32(sizeof (*uc));
 	if (sip != NULL)
 		minstacksz += SA32(sizeof (siginfo32_t));
+
+	if (fpu_xsave_enabled()) {
+		xsave_size = SA32(fpu_signal_size(lwp));
+		minstacksz += xsave_size;
+	} else {
+		xsave_size = 0;
+	}
 	ASSERT((minstacksz & (STACK_ALIGN32 - 1)) == 0);
 
 	/*
@@ -540,13 +580,20 @@
 		}
 	} else
 		sip_addr = NULL;
+	no_fault();
 
 	/* save the current context on the user stack */
+	tuc = kmem_alloc(sizeof (*tuc), KM_SLEEP);
 	fp -= SA32(sizeof (*tuc));
 	uc = (ucontext32_t *)fp;
-	tuc = kmem_alloc(sizeof (*tuc), KM_SLEEP);
-	no_fault();
-	savecontext32(tuc, &lwp->lwp_sigoldmask);
+	if (xsave_size != 0) {
+		fp -= xsave_size;
+		tuc->uc_xsave = (int32_t)(uintptr_t)fp;
+	}
+	ret = savecontext32(tuc, &lwp->lwp_sigoldmask, SAVECTXT_F_EXTD |
+	    SAVECTXT_F_ONFAULT);
+	if (ret != 0)
+		goto postfault;
 	if (on_fault(&ljb))
 		goto badstack;
 	copyout_noerr(tuc, uc, sizeof (*tuc));
@@ -620,6 +667,7 @@
 
 badstack:
 	no_fault();
+postfault:
 	if (watched)
 		watch_enable_addr((caddr_t)sp, minstacksz, S_WRITE);
 	if (tuc)
--- old/usr/src/uts/intel/sys/fp.h	Wed Apr 12 20:33:33 2023
+++ new/usr/src/uts/intel/sys/fp.h	Wed Apr 12 20:33:33 2023
@@ -21,7 +21,7 @@
 /*
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2018, Joyent, Inc.
- * Copyright 2022 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  *
  * Copyright (c) 1992, 2010, Oracle and/or its affiliates. All rights reserved.
  */
@@ -135,10 +135,21 @@
  * - round to nearest or even
  * - 64-bit double precision
  * - all exceptions masked
+ *
+ * The 4th ed. SVR4 ABI didn't discuss the value of reserved bits. The ISA
+ * defines bit 6 (0x40) as reserved, but also that it is set (rather than clear,
+ * like many other Reserved bits). We preserve that in our value here.
  */
-#define	FPU_CW_INIT	0x133f
+#define	FPU_CW_INIT	0x137f
 
 /*
+ * This is the Intel mandated form of the default value of the x87 control word.
+ * This is different from what we use and should only be used in the context of
+ * representing that default state (e.g. in /proc xregs).
+ */
+#define	FPU_CW_INIT_HW	0x037f
+
+/*
  * masks and flags for SSE/SSE2 MXCSR
  */
 #define	SSE_IE	0x00000001	/* invalid operation			*/
@@ -301,9 +312,6 @@
 	union _kfpu_u {
 		void *kfpu_generic;
 		struct fxsave_state *kfpu_fx;
-#if defined(__i386)
-		struct fnsave_state *kfpu_fn;
-#endif
 		struct xsave_state *kfpu_xs;
 	} kfpu_u;
 	uint32_t kfpu_status;		/* saved at #mf exception */
@@ -310,9 +318,11 @@
 	uint32_t kfpu_xstatus;		/* saved at #xm exception */
 } kfpu_t;
 
-extern int fp_kind;		/* kind of fp support			*/
-extern int fp_save_mech;	/* fp save/restore mechanism		*/
-extern int fpu_exists;		/* FPU hw exists			*/
+extern int fp_kind;		/* kind of fp support */
+extern int fp_save_mech;	/* fp save/restore mechanism */
+extern int fpu_exists;		/* FPU hw exists */
+extern int fp_elf;		/* FP elf type */
+extern uint64_t xsave_bv_all;	/* Set of enabed xcr0 values */
 
 #ifdef _KERNEL
 
@@ -325,6 +335,7 @@
 extern uint_t fpu_initial_probe(void);
 
 extern void fpu_auxv_info(int *, size_t *);
+extern boolean_t fpu_xsave_enabled(void);
 
 extern void fpnsave_ctxt(void *);
 extern void fpxsave_ctxt(void *);
@@ -341,8 +352,6 @@
 extern void (*fprestore_ctxt)(void *);
 
 extern void fxsave_insn(struct fxsave_state *);
-extern void fpsave(struct fnsave_state *);
-extern void fprestore(struct fnsave_state *);
 extern void fpxsave(struct fxsave_state *);
 extern void fpxrestore(struct fxsave_state *);
 extern void xsave(struct xsave_state *, uint64_t);
@@ -373,6 +382,22 @@
 extern const struct fxsave_state sse_initial;
 extern const struct xsave_state avx_initial;
 
+struct proc;
+struct ucontext;
+extern void fpu_proc_xregs_info(struct proc *, uint32_t *, uint32_t *,
+    uint32_t *);
+extern size_t fpu_proc_xregs_max_size(void);
+extern void fpu_proc_xregs_get(struct _klwp *, void *);
+extern int fpu_proc_xregs_set(struct _klwp *, void *);
+extern int fpu_signal_copyin(struct _klwp *, struct ucontext *);
+typedef int (*fpu_copyout_f)(const void *, void *, size_t);
+extern int fpu_signal_copyout(struct _klwp *, uintptr_t, fpu_copyout_f);
+extern void fpu_set_xsave(struct _klwp *, const void *);
+extern size_t fpu_signal_size(struct _klwp *);
+
+extern void fpu_get_fpregset(struct _klwp *, fpregset_t *);
+extern void fpu_set_fpregset(struct _klwp *, const fpregset_t *);
+
 #endif	/* _KERNEL */
 
 #ifdef __cplusplus
--- old/usr/src/uts/intel/sys/pcb.h	Wed Apr 12 20:33:33 2023
+++ new/usr/src/uts/intel/sys/pcb.h	Wed Apr 12 20:33:33 2023
@@ -41,10 +41,8 @@
 typedef struct fpu_ctx {
 	kfpu_t		fpu_regs;	/* kernel save area for FPU */
 	uint64_t	fpu_xsave_mask;	/* xsave mask for FPU/SSE/AVX */
-#if defined(__i386)
-	uint64_t	fpu_padding;	/* fix 32bit libmicro regression */
-#endif
 	uint_t		fpu_flags;	/* FPU state flags */
+	void		*fpu_signal;	/* copyin area for signal handling */
 } fpu_ctx_t;
 
 typedef struct pcb {
--- old/usr/src/uts/intel/sys/procfs_isa.h	Wed Apr 12 20:33:34 2023
+++ new/usr/src/uts/intel/sys/procfs_isa.h	Wed Apr 12 20:33:34 2023
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #ifndef _SYS_PROCFS_ISA_H
 #define	_SYS_PROCFS_ISA_H
 
@@ -112,6 +116,141 @@
 #define	R_R1	EDX
 #endif
 
+/*
+ * The x86 xregs structure is a blob of data that contains a header with several
+ * descriptors that describe the region of additional data that corresponds to
+ * it. Effectively this looks like:
+ *
+ * 0  +-----------------+
+ *    | prxregset_hdr_t |
+ *    +-----------------+
+ *    | Info 0 (XCR)    |-------+
+ *    +-----------------+       |
+ *    | Info 1 (XSAVE)  |----------+
+ *    +-----------------+       |  |
+ *           ...                |  |
+ *    +-----------------+       |  |
+ *    | Info n (Hi ZMM) |-------------+
+ *    +-----------------+       |  |  |
+ *    +-----------------+       |  |  |
+ *    | prxregset_xcr_t |<------+  |  |
+ *    +-----------------+          |  |
+ *    +-------------------+        |  |
+ *    | prxregset_xsave_t |<-------+  |
+ *    |                   |           |
+ *    | XMM + xsave       |           |
+ *    +-------------------+           |
+ *           ...                      |
+ *    +---------------------+         |
+ *    | prxregset_hi_zmm_t  |<--------+
+ *    |                     |
+ *    | 1 KiB %zmm16-%zmm31 |
+ *    +---------------------+
+ *
+ * The actual structure size will vary based on the CPU features present. For
+ * more information, see proc(5). When adding structures, please make sure all
+ * structures are multiples of 16 bytes (0x10) so as to ensure alignment.
+ */
+typedef struct prxregset prxregset_t;
+
+#define	PRX_INFO_XCR	0x01
+#define	PRX_INFO_XSAVE	0x02
+#define	PRX_INFO_YMM	0x03
+#define	PRX_INFO_OPMASK	0x04
+#define	PRX_INFO_ZMM	0x05
+#define	PRX_INFO_HI_ZMM	0x06
+
+typedef struct prxregset_info {
+	uint32_t pri_type;
+	uint32_t pri_flags;
+	uint32_t pri_size;
+	uint32_t pri_offset;
+} prxregset_info_t;
+
+#define	PR_TYPE_XSAVE	0x01
+
+typedef struct prxregset_hdr {
+	uint32_t	pr_type;
+	uint32_t	pr_size;
+	uint32_t	pr_flags;
+	uint32_t	pr_pad[4];
+	uint32_t	pr_ninfo;
+#if defined(_STDC_C99) || defined(__C99FEATURES__)
+	prxregset_info_t pr_info[];
+#endif
+} prxregset_hdr_t;
+
+typedef struct prxregset_xcr {
+	uint64_t	prx_xcr_xcr0;
+	uint64_t	prx_xcr_xfd;
+	uint64_t	prx_xcr_pad[2];
+} prxregset_xcr_t;
+
+typedef struct prxregset_xsave {
+	uint16_t	prx_fx_fcw;
+	uint16_t	prx_fx_fsw;
+	uint16_t	prx_fx_fctw;	/* compressed tag word */
+	uint16_t	prx_fx_fop;
+#if defined(__amd64)
+	uint64_t	prx_fx_rip;
+	uint64_t	prx_fx_rdp;
+#else
+	uint32_t	prx_fx_eip;
+	uint16_t	prx_fx_cs;
+	uint16_t	__prx_fx_ign0;
+	uint32_t	prx_fx_dp;
+	uint16_t	prx_fx_ds;
+	uint16_t	__prx_fx_ign1;
+#endif
+	uint32_t	prx_fx_mxcsr;
+	uint32_t	prx_fx_mxcsr_mask;
+	union {
+		uint16_t prx_fpr_16[5];	/* 80-bits of x87 state */
+		u_longlong_t prx_fpr_mmx;	/* 64-bit mmx register */
+		uint32_t _prx__fpr_pad[4];	/* (pad out to 128-bits) */
+	} fx_st[8];
+#if defined(__amd64)
+	upad128_t	prx_fx_xmm[16];	/* 128-bit registers */
+	upad128_t	__prx_fx_ign2[6];
+#else
+	upad128_t	prx_fx_xmm[8];	/* 128-bit registers */
+	upad128_t	__prx_fx_ign2[14];
+#endif
+	uint64_t	prx_xsh_xstate_bv;
+	uint64_t	prx_xsh_xcomp_bv;
+	uint64_t	prx_xsh_reserved[6];
+} prxregset_xsave_t;
+
+typedef struct prxregset_ymm {
+#if defined(__amd64)
+	upad128_t	prx_ymm[16];
+#else
+	upad128_t	prx_ymm[8];
+	upad128_t	prx_rsvd[8];
+#endif
+} prxregset_ymm_t;
+
+typedef struct prxregset_opmask {
+	uint64_t	prx_opmask[8];
+} prxregset_opmask_t;
+
+typedef struct prxregset_zmm {
+#if defined(__amd64)
+	upad256_t	prx_zmm[16];
+#else
+	upad256_t	prx_zmm[8];
+	upad256_t	prx_rsvd[8];
+#endif
+} prxregset_zmm_t;
+
+typedef struct prxregset_hi_zmm {
+#if defined(__amd64)
+	upad512_t	prx_hi_zmm[16];
+#else
+	upad512_t	prx_rsvd[16];
+#endif
+} prxregset_hi_zmm_t;
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/uts/intel/sys/ucontext.h	Wed Apr 12 20:33:34 2023
+++ new/usr/src/uts/intel/sys/ucontext.h	Wed Apr 12 20:33:34 2023
@@ -22,6 +22,7 @@
 /*
  * Copyright 2015 Joyent, Inc.
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2023 Oxide Computer Company
  *
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -82,18 +83,19 @@
 #endif
 	unsigned long	uc_flags;
 	ucontext_t	*uc_link;
-	sigset_t   	uc_sigmask;
-	stack_t 	uc_stack;
-	mcontext_t 	uc_mcontext;
+	sigset_t	uc_sigmask;
+	stack_t		uc_stack;
+	mcontext_t	uc_mcontext;
 	/*
-	 * The Intel386 ABI specification includes a 5-element array of longs
-	 * called "uc_filler", padding the size of the struct to 512 bytes.  To
-	 * allow zone brands to communicate extra data right the way through
-	 * the signal handling process, from sigacthandler to setcontext, we
-	 * steal the first three of these longs as a brand-private member.
+	 * The first three entries have been borrowed by the lx brand right now.
+	 * That should be consolidated into a single uc_brand entry with a
+	 * UC_BRAND flag. Until such time, we leave them as is.
+	 *
+	 * We rename those first three entries here for SmartOS.
 	 */
 	void		*uc_brand_data[3];
-	long		uc_filler[2];
+	long		uc_xsave;
+	long		uc_filler1;
 };
 #if defined(_SYSCALL32)
 
@@ -106,7 +108,8 @@
 	stack32_t	uc_stack;
 	mcontext32_t	uc_mcontext;
 	caddr32_t	uc_brand_data[3];
-	int32_t		uc_filler[2];
+	int32_t		uc_xsave;
+	int32_t		uc_filler1;
 } ucontext32_t;
 
 #if defined(_KERNEL)
@@ -121,6 +124,7 @@
 #define	SETCONTEXT	1
 #define	GETUSTACK	2
 #define	SETUSTACK	3
+#define	GETCONTEXT_EXTD	4
 
 /*
  * values for uc_flags
@@ -134,6 +138,7 @@
 #define	UC_CPU		0x04
 #define	UC_MAU		0x08
 #define	UC_FPU		UC_MAU
+#define	UC_XSAVE	0x10
 
 #define	UC_MCONTEXT	(UC_CPU|UC_FPU)
 
@@ -145,11 +150,44 @@
 #endif /* !defined(_XPG4_2) || defined(__EXTENSIONS__) */
 
 #ifdef _KERNEL
-void savecontext(ucontext_t *, const k_sigset_t *);
+/*
+ * This structure is the private header for the xsave data that we end up
+ * sending to the stack. This is basically our own compressed form. See,
+ * uts/intel/os/fpu.c for more information.
+ */
+#define	UC_XSAVE_VERS	(('u' << 24) | ('c' << 16) | 0x01)
+typedef struct uc_xsave {
+	uint32_t ucx_vers;
+	uint32_t ucx_len;
+	uint64_t ucx_bv;
+} uc_xsave_t;
+
+typedef enum {
+	/*
+	 * Do a boring old savecontext() where we assume that only the data
+	 * structure that we're given must be filled in.
+	 */
+	SAVECTXT_F_NONE = 0,
+	/*
+	 * Indicate that we should treat the ucontext_t as having valid user
+	 * pointers for copying out extended state. Currently this means that we
+	 * treat the uc_xsave member as something that points to a user address.
+	 */
+	SAVECTXT_F_EXTD	= 1 << 0,
+	/*
+	 * This indicates that we shouldn't do normal copyout handling and need
+	 * to actually avoid potentially triggering a watchpoint because we're
+	 * probably in signal handling context.
+	 */
+	SAVECTXT_F_ONFAULT = 1 << 1
+} savecontext_flags_t;
+
+int savecontext(ucontext_t *, const k_sigset_t *, savecontext_flags_t);
 void restorecontext(ucontext_t *);
 
 #ifdef _SYSCALL32
-extern void savecontext32(ucontext32_t *, const k_sigset_t *);
+extern int savecontext32(ucontext32_t *, const k_sigset_t *,
+    savecontext_flags_t);
 #endif
 #endif
 
--- old/usr/src/uts/intel/sys/x86_archext.h	Wed Apr 12 20:33:34 2023
+++ new/usr/src/uts/intel/sys/x86_archext.h	Wed Apr 12 20:33:34 2023
@@ -1437,7 +1437,7 @@
 
 /*
  * xgetbv/xsetbv support
- * See section 13.3 in vol. 1 of the Intel devlopers manual.
+ * See section 13.3 in vol. 1 of the Intel Developer's manual.
  */
 
 #define	XFEATURE_ENABLED_MASK	0x0
@@ -1445,13 +1445,27 @@
  * XFEATURE_ENABLED_MASK values (eax)
  * See setup_xfem().
  */
-#define	XFEATURE_LEGACY_FP	0x1
-#define	XFEATURE_SSE		0x2
-#define	XFEATURE_AVX		0x4
-#define	XFEATURE_MPX		0x18	/* 2 bits, both 0 or 1 */
-#define	XFEATURE_AVX512		0xe0	/* 3 bits, all 0 or 1 */
+#define	XFEATURE_LEGACY_FP	(1 << 0)
+#define	XFEATURE_SSE		(1 << 1)
+#define	XFEATURE_AVX		(1 << 2)
+/*
+ * MPX is meant to be all or nothing, therefore for most of the kernel use the
+ * following definition.
+ */
+#define	XFEATURE_MPX_BNDREGS	(1 << 3)
+#define	XFEATURE_MPX_BNDCSR	(1 << 4)
+#define	XFEATURE_MPX		(XFEATURE_MPX_BNDREGS | XFEATURE_MPX_BNDCSR)
+/*
+ * AVX512 is meant to be all or nothing, therefore for most of the kernel use
+ * the following definition.
+ */
+#define	XFEATURE_AVX512_OPMASK	(1 << 5)
+#define	XFEATURE_AVX512_ZMM	(1 << 6)
+#define	XFEATURE_AVX512_HI_ZMM	(1 << 7)
+#define	XFEATURE_AVX512		(XFEATURE_AVX512_OPMASK | \
+	XFEATURE_AVX512_ZMM | XFEATURE_AVX512_HI_ZMM)
 	/* bit 8 unused */
-#define	XFEATURE_PKRU		0x200
+#define	XFEATURE_PKRU		(1 << 9)
 #define	XFEATURE_FP_ALL	\
 	(XFEATURE_LEGACY_FP | XFEATURE_SSE | XFEATURE_AVX | XFEATURE_MPX | \
 	XFEATURE_AVX512 | XFEATURE_PKRU)
@@ -1576,8 +1590,9 @@
 extern uint_t cpuid_get_procnodes_per_pkg(struct cpu *cpu);
 extern uint_t cpuid_get_compunitid(struct cpu *cpu);
 extern uint_t cpuid_get_cores_per_compunit(struct cpu *cpu);
-extern size_t cpuid_get_xsave_size();
-extern boolean_t cpuid_need_fp_excp_handling();
+extern size_t cpuid_get_xsave_size(void);
+extern void cpuid_get_xsave_info(uint64_t, size_t *, size_t *);
+extern boolean_t cpuid_need_fp_excp_handling(void);
 extern int cpuid_is_cmt(struct cpu *);
 extern int cpuid_syscall32_insn(struct cpu *);
 extern int getl2cacheinfo(struct cpu *, int *, int *, int *);
